import matplotlib.pyplot as plt
import matplotlib.mlab as mlab
import itertools



def hist(values, buckets=50, facecolor='green'):
    """ Plot a histogram of values using matplotlib """
    fig = plt.figure()
    ax = fig.add_subplot(111)
    ax.hist(values, buckets, facecolor='green')
    plt.show()

def channel_usage(messagelist):
    fig, ax = plt.subplots()
    box_height=0.8

    all_message_ids=set([m.message_id for m in messagelist])
    sorted_ids=list(all_message_ids)
    sorted_ids.sort()
    print "Sorted ids ",sorted_ids

    colorcycle=itertools.cycle(['red','blue','green','brown','black','yellow'])
    intergap_color='grey'


    message_id_color=dict()
    message_id_ypos=dict()

    min_x=None
    max_x=None
    min_y=0
    max_y=None
    for (index,message_id) in enumerate(sorted_ids):
        message_id_ypos[message_id]=index+0.6
        message_id_color[message_id]=next(colorcycle)
        max_y=index+5

        ax.plot([1], label="%04X" % message_id, color=message_id_color[message_id], linewidth=10)

    def add_box(x,y,width,height,color):
        rect = plt.Rectangle((x, y), width, height, facecolor=color, linewidth=0)
        plt.gca().add_patch(rect)
        
    for m in messagelist:
        duration=m.calculate_duration()
        endtime=m.timestamp
        starttime=endtime-duration

        if not min_x:
            min_x=starttime
        elif starttime < min_x:
            min_x=starttime

        if not max_x:
            max_x=endtime
        elif endtime > max_x:
            max_x=endtime
            
        ypos=message_id_ypos[m.message_id]
        color=message_id_color[m.message_id]

        add_box(starttime, ypos, duration, box_height, color)

        intergap_duration=m.calculate_inter_frame_gap()
        add_box(endtime, ypos, intergap_duration, box_height, intergap_color)



    plt.ylim(min_y,max_y)
    plt.xlim(min_x,max_x)
    plt.legend()
    plt.grid(True)
    plt.show()
