#!/usr/bin/python
# -*- coding: utf-8 -*-

import socket
import select
import argparse
from datetime import datetime

UDP_IP = "0.0.0.0"
UDP_PORT = 5006


parser = argparse.ArgumentParser(description='Tool to receive and store messages from the Schnueffel')
parser.add_argument('--udp_port', '-p', type=int, default=UDP_PORT)
parser.add_argument('--timeout', '-t', type=int, default=2)
parser.add_argument

args = parser.parse_args()

sock = socket.socket(   socket.AF_INET, # Internet
                        socket.SOCK_DGRAM
                    ) # UDP

print("Listening on all interfaces, udp port %s" % args.udp_port)
sock.bind((UDP_IP, args.udp_port))
sock.setblocking(0)

try:
# This will create a new file or **overwrite an existing file**.

    now = datetime.now().replace(microsecond=0)
    filename= "trace_"+now.isoformat("_").replace(":","")+".txt"
    print("Logging to %s" % filename)
    f = open(filename, "w")
    try:
        while True:
            ready = select.select([sock], [], [], args.timeout) 
            if ready[0]:
                data, addr = sock.recvfrom(4096) # buffer size is 4096 bytes
                print "received message:", data
                f.write(data) # Write a string to a file
            else:
                print "Timeout!"
                break
    finally:
        f.close()
except IOError:
    print "IO Error!"
    pass


